    member

    map
    
    end

    include('fsdates.inc')

!methods -----------------------------------------------------------------

fsdatesClass.Construct              procedure
    code


fsdatesClass.Destruct               procedure
    code


fsdatesClass.CalcPeriodExpired       procedure(LONG Startdate, LONG FinishDate, BYTE DateType)
DateString  STRING(100)
DYear       LONG
DMonth      LONG
DDay        LONG
TYears      LONG
TMonths     LONG
TDays       LONG

    code
    self.AllocateValues(Startdate,Finishdate)
    DYear=self.calcyearsExpired(Startdate,Finishdate)
    DMonth = self.CalcMonthsExpired(Startdate,Finishdate)
    DDay = self.CalcDaysExpired(Startdate,Finishdate)
    DateString = 'Time Expired - ' & DYear & ' Years ' & DMonth & ' Months ' & DDay & ' Days'
    Case DateType
        of 0
            return DateString
        of 1
            return DYear
        of 2
            return DMonth
        of 3
            return DDay
        of 4
            return FinishDate - StartDate
    end

fsdatesClass.AllocateValues          procedure(LONG StartDate, LONG FinishDate)
    code
    ! allocate values and get the rough year count
    self.FYear = year(Finishdate) - Year(Startdate)
    self.FMonth = Month(FinishDate)
    self.SMonth = Month(StartDate)
    self.FDay   = Day(FinishDate)
    self.SDay   = DAY(StartDate)


fsdatesClass.CalcYearsExpired        procedure(LONG Startdate, LONG FinishDate)
    code
    ! check for completed months
    if self.FMonth < self.SMonth then
        self.FYear -= 1
    elsif self.FMonth > self.SMonth then
        self.FYear = self.FYear
    elsif  self.FMonth = self.SMonth then
        if self.Fday >= self.SDay then
            self.FYear = self.FYear
        elsif self.FDay < self.SDay then
            self.FYear -= 1
            
        end
    end
    return self.FYear


fsdatesClass.CalcMonthsExpired       procedure(LONG Startdate, LONG FinishDate)
RMonth  LONG

    code
    If self.FMonth > self.SMonth then
        RMonth = self.FMonth - self.SMonth
    elsif self.FMonth < self.SMonth then
        RMonth = (12 - self.SMonth) + self.FMonth
    elsif self.FMonth = self.SMonth then
        if self.FDay >= self.SDay then
            RMonth = 0
        else
            RMonth -= 1
            ! could not allocate 12 months when same month 12 months apart
            if year(Finishdate) - Year(Startdate) > 0 then
                RMonth = 11
            end

        end
    end
    Return RMonth

fsdatesClass.CalcDaysExpired       procedure(LONG Startdate, LONG FinishDate)
RMonth  LONG
RDay    LONG
LastDate LONG

    code
    If self.FMonth > self.SMonth then
        RMonth = self.FMonth - self.SMonth
    elsif self.FMonth < self.SMonth then
        RMonth = (12 - self.SMonth) + self.FMonth
    elsif self.FMonth = self.SMonth then
        if self.FDay >= self.SDay then
            RMonth = 0
        else
            RMonth -= 1
            ! could not allocate 12 months when same month 12 months apart
            if year(Finishdate) - Year(Startdate) > 0 then
                RMonth = 11
            end

        end
    end
    ! get the last date and calc the remaining days left
    LastDate = date(self.SMonth+RMonth,self.SDay,Year(StartDate)+self.FYear)
    Rday = FinishDate - LastDate
    Return RDay

